function get_random_background() {

    // determine whether or not to use a video background or a picture
    function getRandom(min, max) {
        min = Math.ceil(min);
        max = Math.floor(max);
        return Math.floor(Math.random() * (max - min + 1)) + min;
    };

    var ran = getRandom(1, 2),
        media_format = (ran == 1) ? "video" : "img",
        background;

    if (media_format == "video") {

        var i = getRandom(0, img_video_map.video.length - 1);
        background = img_video_map.video[i];

    };

    if (media_format == "img") {

        var i = getRandom(0, img_video_map.img.length - 1);
        background = img_video_map.img[i];

    };

    // IF USER IS CONNECTED TO INTERNET

    // MANIPULATE URL SO THAT GOOGLE ANALYTICS CAN PIC IT UP
    // THEN, IN REDIRECT.JS, PARSE THE URL TO DETERMINE WHICH BACKGROUND TO USE

    return background;

};

// check to see if time is within schedule
function schedule_checker(schedule) {

    var days = {0: "sun", 1: "mon", 2: "tue", 3: "wed", 4: "thu", 5: "fri", 6: "sat"};

    var current_date = new Date(),
        day = days[current_date.getDay()];

    var today = new Date(),
        time = today.getHours() + ":" + today.getMinutes();

    // the day of the week is active
    if (schedule.days[day] == true) {

        // the time of day is active
        if ( Date.parse(schedule.times.from) < current_date && Date.parse(schedule.times.to) > current_date ) {
            return true;
        };

    };

    return false;

};

// this will use the chrome API to generate a URL that the user will be redirected to
// TODO - within this function you will need to add more logic for a few things, here's the main ones
//      WHITELIST MODE - is it on whitelist mode of blocklist mode?  this will need to be determined
//      WORK MODE - is work mode on?  if it is, that'll effect what you do with the function
var redirect_url = chrome.extension.getURL('redirect.html');
function check_url(details) {

    // see if a url is on the blocklist
    var on_blocklist = function(url) {

        // this is how I'm going to get around people clicking the "I want to continue" button to certain sites
        // it will redirect the user to that site (which usually should be blocked) but with a certain URL parameter that allows it through...
        // this URL parameter will be called jodb-noblock and the value will be set to "true"
        // if (url.indexOf("jodb-noblock=true") != -1) {
        //     return false;
        // }

        // trim the url and get the base URL
        url = helpers.trim_url(url);
        var base_url = url.split("/")[0];

        // this will stay at 'false' until proven otherwise - it will be the value that is returned
        var blocked = false
        // go and check for base_url blocks along with extended url blocks
        for (var i = odb_settings.blocklist.length - 1; i >= 0; i--) {
            
            // current blocklist URL
            var blocked_url = odb_settings.blocklist[i];

            // if it is a root domain only (eg: "google.com"), then just see if base_url if the current_url matches the blocklist item
            if (blocked_url.indexOf("/") == -1) {

                if (blocked_url == base_url) {
                    blocked = true;
                }

            } 
            // if it is an extended domain (eg: "google.com/jobs") then match the whole url
            else {

                if (blocked_url == url) {
                    blocked = true;
                }
            
            }
        
        }

        if (odb_settings.adult_filter == 'true' && adult_site_list.indexOf(base_url) != -1) {
            blocked = true;
        }

        return blocked;

    }

    // IF THE MAIN PAUSE BUTTON TIMER IS ACTIVE, DO NOT BLOCK
    var current_time = new Date,
        time = Date.parse(odb_settings.master_timer);

    if (current_time <= time && odb_settings.master_timer != '' && odb_settings.master_timer != null && time != null) {
        return {};
    } 
      else if (odb_settings.schedule_mode_master_switch == 'true' && (schedule_checker(odb_settings.schedules[0]) == false)) { // SCHEDULE MODE ON AND NOT WITHIN SCHEDULE, DO NOT BLOCK 
        return {};
    } 
        else // TIMER NOT ON, SCHEDULE MODE MAY BE ACTIVE, BLOCK THAT SHIT - BLOCK
    {
    
        // the URL that the user is trying to navigate to
        var current_url = details.url;

        // FOR TESTING PURPOSES ONLY
        // return {redirectUrl: current_url + "&origin=" + current_url};

        // if you're about to redirect to the chrome-extension, then DON'T EVER REDIRECT
        // this will make it so that you can access other chrome extensions too 
        if (current_url.indexOf("chrome-extension://") != -1) {
            return {};
        }

        // if the master switch is off, then don't redirect
        if (odb_settings.master_switch == 'false') {
            return {};
        }

        // this needs to encompass more logic
        if (on_blocklist(current_url)) {
        
            // get a random background to pass to the url
            var background = get_random_background();

            odb_settings.exceptions = (typeof odb_settings.exceptions === 'undefined') ? [] : odb_settings.exceptions;
            var matching_exceptions = odb_settings.exceptions.filter(function(e){return e.url == helpers.base_url(current_url);});
            if (matching_exceptions.length > 0) {

                matching_exceptions = matching_exceptions[0];

                var current_time = new Date;
                var exception_time = Date.parse(matching_exceptions.time);

                if (exception_time > current_time) {
                    return {};
                }

            }

            // pass the URL the user wanted to go to as a URL parameter "?"
            return {redirectUrl: redirect_url + "?background=" + background.id.toString() + "&type=" + background.type + "&origin=" + current_url};

        } else {
            
            return {};

        }

    };


};