// general helpers for URLs and reading
var helpers = {
	
	// this will format URLs in a format that removes the HTTPS or HTTP or FTP from the beginning...
	trim_url: function(url) {

		// this will contain an array that splits on the ://
		// eg: ["https", "google.com"]
		// all you have to do after this is take the elements that come after the split and combine them back together
		var split = url.split("://"),
			new_url = "";

		// if there is a :// in the URL then grab everything after the ://
		if (split.length > 1) {
	
			for (var i = 1; i < split.length; i++) {
				new_url = new_url + split[i];
			}
			
		} else {
			new_url = url;
		}

		// if there is a www. then remove it
		if (new_url.indexOf("www.") == 0) {
			new_url = new_url.substring(4);
		}

		// if there are URL parameters or fragments ('#click-here') then remove them...
		 var strip_parameters = function(old_url) {
			
			var	index = 0,
				return_url = old_url;

			index = old_url.indexOf('?');
			
			if (index == -1) {
			    index = old_url.indexOf('#');
			}

			if (index != -1) {
			    return_url = old_url.substring(0, index);
			}

			return return_url

		};
		new_url = strip_parameters(new_url);

		// if the last character of the url is a '/', then go ahead and remove it
		if (new_url.indexOf("/") == new_url.length - 1) {
			new_url = new_url.substring(0, new_url.length - 1);
		}

		return new_url.toLowerCase();
	},

	base_url: function(url) {


		url = helpers.trim_url(url);
		return url.split("/")[0];
	
	},

	// this will determine whether or not the user <input> contains a valid URL - it doesn't need an HTTPS or HTTP
	// it will also check to see if it is already on the blocklist
	// it will grab the value straight from the <input>, so you don't need a parameter
	// it will return 'true' boolean if good, 'false' if bad
	validate_url: function(url, settings = {}) {

		url = url.toLowerCase();
		
		// this will simply determine whether or not the URL is valid
		var validURL = function (str) {
		
		 	var pattern = new RegExp('^(https?:\\/\\/)?'+ // protocol
			    '((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.)+[a-z]{2,}|'+ // domain name
			    '((\\d{1,3}\\.){3}\\d{1,3}))'+ // OR ip (v4) address
			    '(\\:\\d+)?(\\/[-a-z\\d%_.~+]*)*'); // port and path
		  	
		  	return !!pattern.test(str);
		
		};

		// this will check to see if the URL is already on the blocklist or not
		var uniqueURL = function(url) {

			var url = helpers.trim_url(url);

			// if (blocklist.indexOf(url) == -1) {
			if (blocklist.indexOf(url) == -1) {
				return true;
			}

			return false;

		};

		// if it is not a valid URL, then send a toast for user error
		// only run this in the "options" portion, as every URL from "popup" should be a valid URL
		if (validURL(url) == false && settings.run_type != "popup") {
			return {val: false, code: "valid", msg: "Please enter a valid URL"};
		}


		// if the URL is already on the blocklist, then toast for user error
		if (uniqueURL(url) == false) {
			return {val: false, code: "unique", msg: "This site is already on your blocklist"};
		};

		// otherwise, return true
		return {val: true}
	},

	get_json_from_url: function(url) {
		if(!url) url = location.href;
		var question = url.indexOf("?");
		var hash = url.indexOf("#");
		if(hash==-1 && question==-1) return {};
		if(hash==-1) hash = url.length;
		var query = question==-1 || hash==question+1 ? url.substring(hash) : 
		url.substring(question+1,hash);
		var result = {};
		query.split("&").forEach(function(part) {
			if(!part) return;
			part = part.split("+").join(" "); // replace every + with space, regexp-free version
			var eq = part.indexOf("=");
			var key = eq>-1 ? part.substr(0,eq) : part;
			var val = eq>-1 ? decodeURIComponent(part.substr(eq+1)) : "";
			var from = key.indexOf("[");
			if(from==-1) result[decodeURIComponent(key)] = val;
			else {
			  var to = key.indexOf("]",from);
			  var index = decodeURIComponent(key.substring(from+1,to));
			  key = decodeURIComponent(key.substring(0,from));
			  if(!result[key]) result[key] = [];
			  if(!index) result[key].push(val);
			  else result[key][index] = val;
			}
		});
		return result;
	}

}