function redirect_if_onboarded() {

	// if the user already has a blocklist setup, don't onboard them
	core.get_blocklist(function(){

		if (blocklist.length > 0) {
			document.location.href = chrome.extension.getURL('options.html');
		}

	});

};

// this will set the default value for the schedule
function set_defaults() {

	// default schedule if the user hasn't set one will be 9 to 5 every day of the week
	chrome.storage.sync.get("schedules", function(result) {

		var schedules = result.schedules;
		
		if (typeof schedules === 'undefined' || schedules == '') {
			
			schedules = [
				{
					times: {
						from: "09:00 AM",
						to:  "05:00 PM"
					},
					days: {
						mon: true, tue: true, wed: true, thu: true, fri: true, sat: true, sun: true 
					}
				}
			];

			// set new default schedules and re-run program
			chrome.storage.sync.set({
				schedules: schedules
		  	}, function() {
		  		chrome.runtime.sendMessage({request: 'update_settings'});
		  	});

		};

	});

}

var default_transition_time = 1500;

chrome.storage.sync.set({master_switch: "true"}, function(){
	chrome.runtime.sendMessage({request: 'update_settings'});
});

$(document).ready(function(){
	
	set_defaults();
	redirect_if_onboarded();
	blocklist_frame(); // RUN

});
