function mailchimp_signup(email) {

	var form = $("form#mc-embedded-subscribe-form"),
	    email_input = $("form#mc-embedded-subscribe-form #mce-EMAIL");

	email_input.val(email);
	
	$form = form;

	$.ajax({
	    type: 'POST',
	    url: $form.attr("action"),
	    data: $form.serialize(),
	    cache: false,
	    dataType: "jsonp",
	    jsonp: "c",
	    contentType: "application/json; charset=utf-8",
	    error: function(err) {
	      console.log("mailchimp error");
	    },
	    success: function(data) {
	      console.log("mailchimp success");
	    }
	});

} 

function email_frame() {

	// if they get to frame 2, you might as well onboard them
	chrome.storage.sync.set({onboarded: "true"}, function() {});

	var default_transition_time = 1500;

	var email_frame = $("#email-frame"),
		email_frame_msg_1 = $("#email-frame #msg-1"),
		email_input_section = $("#email-frame .input-section"),
		email_input = $("#email-frame .input-section input"),
		error_text = $("#email-frame .error-text"),
		skip_text = $("#email-frame #skip-text"),
		opt_in = $("#email-frame #opt-in");

	function validateEmail(email) {
		var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
	    return re.test(String(email).toLowerCase());
	};

	// this'll be used to go to the next frame
	// PASS A FUNCTION HERE, IT COULD EITHER BE OPT-IN OR THANK-YOU
	function transition_to_next_frame(next_frame, params) {

		params = params || {};

		var default_transition_time = 1000;

		$("#email-frame").animate({"opacity": 0}, default_transition_time, "swing", function(){
			
			$("#email-frame").remove();

			next_frame(params);

		});

	};

	function fade_in_frame() {

		email_frame.css("display", "block");

		email_frame.fadeOut(0, function(){
			
			email_frame.fadeIn(default_transition_time, function(){

				email_input.attr("autofocus", "");
				email_input.focus();

			});

		});

	};

	function interaction() {

		// opt_in.on("click", function(){
		// 	opt_in.toggleClass("on");
		// 	$("#checkbox", opt_in).toggleClass("on");
		// });

		email_input.on("keypress", function(e){ if (e.which == 13) {

			var email = $("#email-frame .input-section input").val(),
				valid_email = validateEmail(email);

			// if the email is valid
			if (valid_email == true) {

				// _gaq.push(['_trackEvent', "email-frame-email-submitted", 'true']);

				mailchimp_signup(email);
				transition_to_next_frame(welcome_frame);

			} else { //email is not valid

				// _gaq.push(['_trackEvent', "email-frame-invalid-email", 'true']);

				error_text.css("opacity", 0) // change the opacity to "0"
					.delay(500)
					.queue(function(next){
						
						error_text
							.css("opacity", 1)
							.html("Whoops, that doesn't look like a valid email.");

						next();
					
					});

			}

		}});

		skip_text.on("click", function() {

			// _gaq.push(['_trackEvent', "email-frame-skip-email", 'true']);

			transition_to_next_frame(welcome_frame);

		});

	};

	function run() {
		fade_in_frame();
		interaction();
	};

	run();

};