// this will setup the blocklist and allow it to be manipulated locally
// the reason you have to do this is because of async within JS and the chrome API (fucking christ)
var blocklist;

// because of how the chrome.storage API works, you'll need to nest each instance where you grab data from the storage API within the chrome.storage.sync.get CALLBACK FUNCTION
// due to this, I'm creating a simple helper method that will take the data value from "result.blocklist" and format it properly if it's null or undefined
var get_blocklist = function(callback = function(){}) {
	
	var format_blocklist = function(blocklist) {
		if (typeof blocklist === "object") {return blocklist;}
		return [];
	};
	
	chrome.storage.sync.get('blocklist', function(result) {
		blocklist = format_blocklist(result.blocklist);
		callback();
	});

};

// core.master_switch();
// if site is already on the blocklist then disable the button
// on the onClick make sure that if it has the class "disabled" it doesn't go through

var main = function() {

	get_blocklist();

	// get the current tab URL
	var current_url;
	chrome.windows.getCurrent(function (currentWindow) {
	    
	    chrome.tabs.query({ active: true, windowId: currentWindow.id }, function (activeTabs) {
	    
	        activeTabs.map(function (tab) {
	            
	            var origin = helpers.trim_url(new URL(tab.url).origin),
	            	current_url = origin;

	            // if this is not a http:// website - DO NOT BLOCK IT, AND DO NOT ALLOW IT TO BE BLOCKED
	            if (tab.url.indexOf("http") != 0) {

	            	// fadeOut the favicon
	            	$("img#favicon").fadeOut();
	            	$("#url").text("Sorry, this site can't be blocked!");
	            	$("#add-to-blocklist").addClass("disabled");

	            	// this is if the website is already on the users blocklist
	            } else if ( helpers.validate_url(current_url).val == false ) {

	            	$("img#favicon").attr("src", tab.favIconUrl);
	            	$("#url").text("This site is already blocked!");
	            	$("#add-to-blocklist").addClass("disabled");

	            } else {
					
					$("#url").text(origin);

					$("img#favicon").attr("src", tab.favIconUrl);
					
					// add to blocklist button
					$("#add-to-blocklist.btn").on("click", function(){

						$("#add-to-blocklist.btn").off("click");
							
						// this will just ensure that if the blocklist is empty it doesn't return an undefined value, it'll return an empty array
						var format_blocklist = function(blocklist) {
							if (typeof blocklist === "object") {return blocklist;}
							return [];
						};
						
						chrome.storage.sync.get('blocklist', function(result) {
							
							blocklist = format_blocklist(result.blocklist);

							blocklist.push(origin);

							// set dat value in chrome boi
						  	chrome.storage.sync.set({

						    	// this assumes you can provide a URL for storage
						    	blocklist: blocklist
						  	
						  	}, function() {

						    	$("#add-to-blocklist.btn").addClass("disabled").text("Added!");

						    	chrome.runtime.sendMessage({request: 'update_settings'});

						    	chrome.runtime.sendMessage({
					                request: 'inline_block_popup', 
					                redirect: origin,
					                tab_id: tab.id
					            });

						  	});
							
						});


					});

	            }


	        });

	    });

	});


}();

// '#more-settings' needs to be updated with a link that goes to the chrome-extension:// settings page
var more_settings = function() {
	
	var redirect_url = chrome.extension.getURL('options.html');
	$('#more-settings').attr("href", redirect_url);

	var schedule_url = chrome.extension.getURL('options.html') + "?action=schedule";
	$("#edit-my-schedule-btn").attr("href", schedule_url).attr("target", "_blank");

}();

$(document).ready(function(){
	
	core.initialize();

});